MA_Locked = false;
MA_Tooltips = true;
MA_WMT = false;
MA_Hide = false;
MA_HideOnCombat = false;
MA_GR = 0;
MA_GG = 0;
MA_GB = 0;
MA_GA = 0;
MA_BR = 1;
MA_BG = 1;
MA_BB = 1;
MA_BA = 0;

local LoadFrame = CreateFrame("FRAME");
LoadFrame:RegisterEvent("ADDON_LOADED");
LoadFrame:RegisterEvent("PLAYER_LOGOUT");
LoadFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
LoadFrame:RegisterEvent("PLAYER_REGEN_ENABLED");

function LoadFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "MarkAssistant" then
		if not MarkAssistantDB then
			MarkAssistantDB = {}
		end
		if MarkAssistantDB.locked ~= nil then
			MA_Locked = MarkAssistantDB.locked;
			if MA_Locked == true then
				MA_OptionsFrameCheckButton_Locked:SetChecked(true);
			else
				MA_OptionsFrameCheckButton_Locked:SetChecked(false);
			end
		end
		if MarkAssistantDB.tooltips == nil then
			MA_OptionsFrameCheckButton_Tooltips:SetChecked(true);
		else
			MA_Tooltips = MarkAssistantDB.tooltips;
			if MA_Tooltips == true then
				MA_OptionsFrameCheckButton_Tooltips:SetChecked(true);
			else
				MA_OptionsFrameCheckButton_Tooltips:SetChecked(false);
			end
		end
		if MarkAssistantDB.hide ~= nil then
			MA_Hide = MarkAssistantDB.hide;
			if MA_Hide == true then
				MA_Form:Hide();
			else
				MA_Form:Show();
			end
		end
		if MarkAssistantDB.hideoncombat ~= nil then
			MA_HideOnCombat = MarkAssistantDB.hideoncombat;
			if MA_HideOnCombat == true then
				MA_OptionsFrameCheckButton_HideOnCombat:SetChecked(true);
			else
				MA_OptionsFrameCheckButton_HideOnCombat:SetChecked(false);
			end
		end
		if MarkAssistantDB.red ~= nil and MarkAssistantDB.green ~= nil and MarkAssistantDB.blue ~= nil and MarkAssistantDB.alpha ~= nil then
			MA_GR = MarkAssistantDB.red;
			MA_GG = MarkAssistantDB.green;
			MA_GB = MarkAssistantDB.blue;
			MA_GA = MarkAssistantDB.alpha;
		end
		if MarkAssistantDB.bgred ~= nil and MarkAssistantDB.bggreen ~= nil and MarkAssistantDB.bgblue ~= nil and MarkAssistantDB.bgalpha ~= nil then
			MA_BR = MarkAssistantDB.bgred;
			MA_BG = MarkAssistantDB.bggreen;
			MA_BB = MarkAssistantDB.bgblue;
			MA_BA = MarkAssistantDB.bgalpha;
		end

		MA_Form:SetBackdropColor(MA_GR, MA_GG, MA_GB, (1-MA_GA));
		MA_Form:SetBackdropBorderColor(MA_BR, MA_BG, MA_BB, (1-MA_BA));
		
		SlashCmdList["MarkAssistant"] = SlashCommandHandler;
		SLASH_MarkAssistant1 = "/markassistant";
		SLASH_MarkAssistant2 = "/markassist";
		SLASH_MarkAssistant3 = "/mark";

	elseif event == "PLAYER_LOGOUT" then
		MarkAssistantDB.locked = MA_Locked;
		MarkAssistantDB.tooltips = MA_Tooltips;
		MarkAssistantDB.hide = MA_Hide;
		MarkAssistantDB.hideoncombat = MA_HideOnCombat;
		MarkAssistantDB.red = MA_GR;
		MarkAssistantDB.green = MA_GG;
		MarkAssistantDB.blue = MA_GB;
		MarkAssistantDB.alpha = MA_GA;
		MarkAssistantDB.bgred = MA_BR;
		MarkAssistantDB.bggreen = MA_BG;
		MarkAssistantDB.bgblue = MA_BB;
		MarkAssistantDB.bgalpha = MA_BA;		
	end
	if event == "PLAYER_REGEN_ENABLED" then
		if MA_HideOnCombat == true then
			MA_Form:Show();
		end
	elseif event == "PLAYER_REGEN_DISABLED" then
		if MA_HideOnCombat == true then
			MA_Form:Hide();
			MA_OptionsFrame:Hide();
			MA_Tooltip:Hide();
		end
	end
end

LoadFrame:SetScript("OnEvent", LoadFrame.OnEvent);

function SlashCommandHandler(msg)
	if msg == "show" then
		MA_Form:Show();
		MA_Hide = false;
	elseif msg == "hide" then
		MA_Form:Hide();
		MA_Hide = true;
	elseif msg == "lock" then
		MA_OptionsFrameCheckButton_Locked:SetChecked(true);
		MA_Locked = true;
	elseif msg == "unlock" then
		MA_OptionsFrameCheckButton_Locked:SetChecked(false);
		MA_Locked = false;
	elseif msg == "tooltips" then
		if MA_Tooltips == false then
			MA_OptionsFrameCheckButton_Tooltips:SetChecked(true);
			MA_Tooltips = true;
			MA_HideGameTooltip();
		else
			MA_OptionsFrameCheckButton_Tooltips:SetChecked(false);
			MA_Tooltips = false;
		end
	elseif msg == "combat" then
		if MA_HideOnCombat == false then
			MA_OptionsFrameCheckButton_Locked:SetChecked(true);
			MA_HideOnCombat = true;
		else
			MA_OptionsFrameCheckButton_Locked:SetChecked(false);
			MA_HideOnCombat = false;
		end
	elseif msg == "color" then
		MA_SetColor();
	elseif msg == "border" then
		MA_SetBorderColor();
	elseif msg == "options" or msg == "opts" or msg == "opt" or msg == "config" then
		MA_ShowOptionsFrame();
	elseif msg == "colorreset" or msg == "reset" then
		MA_GR = 0;
		MA_GG = 0;
		MA_GB = 0;
		MA_GA = 0;
		MA_BR = 1;
		MA_BG = 1;
		MA_BB = 1;
		MA_BA = 0;
		MA_Form:SetBackdropColor(MA_GR, MA_GG, MA_GB, (1-MA_GA));
		MA_Form:SetBackdropBorderColor(MA_BR, MA_BG, MA_BB, (1-MA_BA));
	else
		print("|r|c00FFD200MarkAssistant|r by |r|c00ABD473Wraïne|r@|r|c00999999Area 52|r-US");
		print("|r|c00993333To Move:|r Click and Drag any corner (when unlocked)");
		print("|r|c00993333Options:|r Right Click anywhere on the MarkAssistant Frame");
		print("|r|c00993333Commands:|r /markassistant, /markassist, /mark <cmd>");
		print("|r|c00993333<cmd> List:|r show, hide, lock, unlock, tooltips, combat, color, border, colorreset/reset, options");
	end
end

function MA_MarkTarget(iconNum)
	SetRaidTargetIcon("target", iconNum);
end

function MA_ShowGameTooltip(str)
	MA_WMT = false;
	MA_HideWorldMarker();
	if MA_Tooltips == true then
		FrmX, FrmY = MA_Form:GetCenter();
		MA_TooltipText:SetText(str);
		if (FrmY+85+MA_TooltipText:GetHeight()) >= UIParent:GetHeight() then
			MA_Tooltip:SetPoint("BOTTOMLEFT", FrmX-134.5, FrmY-(33+math.floor(MA_TooltipText:GetHeight())));
		else
			MA_Tooltip:SetPoint("BOTTOMLEFT", FrmX-134.5, FrmY+17);
		end
		MA_Tooltip:SetWidth(MA_TooltipText:GetWidth()+21);
		MA_Tooltip:SetHeight(MA_TooltipText:GetHeight()+15);
		MA_Tooltip:Show();
	end
end

function MA_HideGameTooltip()
	MA_Tooltip:Hide();
	MA_TooltipText:SetText("");
end

function MA_ShowWorldMarker()
	FrmX, FrmY = MA_Form:GetCenter();
	if (FrmY+85+MA_WorldMarkerTooltip:GetHeight()) >= UIParent:GetHeight() then
		MA_WorldMarkerTooltip:SetPoint("BOTTOMLEFT", FrmX-134.5, FrmY-(17+math.floor(MA_WorldMarkerTooltip:GetHeight())));
	else
		MA_WorldMarkerTooltip:SetPoint("BOTTOMLEFT", FrmX-134.5, FrmY+17);
	end
	MA_WorldMarkerTooltip:Show();
end

function MA_HideWorldMarker()
	if MA_WMT == false then
		MA_WorldMarkerTooltip:Hide();
	end
end

function MA_ToggleOptionsFrame()
	if MA_OptionsFrame:IsShown() then
		MA_OptionsFrame:Hide();
	else
		MA_ShowOptionsFrame();
	end
end

function MA_ShowOptionsFrame()
	FrmX, FrmY = MA_Form:GetCenter();
	MA_OptionsFrameText:SetText("|r|c00FFD200Options|r\n-----------------");
	if (FrmX+MA_Form:GetWidth()+50+MA_OptionsFrameText:GetWidth()) >= UIParent:GetWidth() then
		MA_OptionsFrame:SetPoint("BOTTOMLEFT", FrmX-(MA_OptionsFrame:GetWidth()+134.5), FrmY-(MA_OptionsFrame:GetHeight()-17.5));
	else
		MA_OptionsFrame:SetPoint("BOTTOMLEFT", FrmX+134.5, FrmY-(MA_OptionsFrame:GetHeight()-17.5));
	end
	MA_OptionsFrame:Show();
end

function MA_HideOptionsFrame()
	MA_OptionsFrame:Hide();
end

function MA_SetLocked(self)
	if self:GetChecked() == true then
		MA_Locked = true;
	else
		MA_Locked = false;
	end
end

function MA_SetTooltips(self)
	if self:GetChecked() == true then
		MA_Tooltips = true;
	else
		MA_Tooltips = false;
		MA_HideGameTooltip();
	end
end

function MA_SetHideOnCombat(self)
	if self:GetChecked() == true then
		MA_HideOnCombat = true;
	else
		MA_HideOnCombat = false;
	end
end

function MA_SetColor()
	ShowColorPicker(MA_GR, MA_GG, MA_GB, MA_GA);
end

function MA_SetBorderColor()
	ShowBorderColorPicker(MA_BR, MA_BG, MA_BB, MA_BA);
end

function ShowColorPicker(r, g, b, a)
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = ColorCallback, ColorCallback, ColorCallback;
	ColorPickerFrame.previousValues = {r,g,b,a};
	ColorPickerFrame:SetColorRGB(r,g,b);
	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
	ColorPickerFrame:Hide();
	ColorPickerFrame:Show();
end

function ShowBorderColorPicker(r, g, b, a)
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = BorderColorCallback, BorderColorCallback, BorderColorCallback;
	ColorPickerFrame.previousValues = {r,g,b,a};
	ColorPickerFrame:SetColorRGB(r,g,b);
	ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
	ColorPickerFrame:Hide();
	ColorPickerFrame:Show();
end

function ColorCallback(restore)
	if restore then
		MA_GR, MA_GG, MA_GB, MA_GA = unpack(restore);
	else
		MA_GA, MA_GR, MA_GG, MA_GB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end
	MA_Form:SetBackdropColor(MA_GR, MA_GG, MA_GB, (1-MA_GA));
end

function BorderColorCallback(restore)
	if restore then
		MA_BR, MA_BG, MA_BB, MA_BA = unpack(restore);
	else
		MA_BA, MA_BR, MA_BG, MA_BB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end
	MA_Form:SetBackdropBorderColor(MA_BR, MA_BG, MA_BB, (1-MA_BA));
end